Remove OpenSuse13.2 from runtime section in all Project.Jsons
[platform/upstream/coreclr.git] / build.sh
1 #!/usr/bin/env bash
2
3 # resolve python-version to use
4 if [ "$PYTHON" == "" ] ; then
5     if ! PYTHON=$(command -v python || command -v python2 || command -v python 2.7)
6     then
7        echo "Unable to locate build-dependency python2.x!" 1>&2
8        exit 1
9     fi
10 fi
11
12 # validate python-dependency
13 # useful in case of explicitly set option.
14 if ! command -v $PYTHON > /dev/null
15 then
16    echo "Unable to locate build-dependency python2.x ($PYTHON)!" 1>&2
17    exit 1
18 fi
19
20 usage()
21 {
22     echo "Usage: $0 [BuildArch] [BuildType] [verbose] [coverage] [cross] [clangx.y] [ninja] [configureonly] [skipconfigure] [skipnative] [skipmscorlib] [skiptests] [cmakeargs] [bindir]"
23     echo "BuildArch can be: x64, x86, arm, armel, arm64"
24     echo "BuildType can be: debug, checked, release"
25     echo "coverage - optional argument to enable code coverage build (currently supported only for Linux and OSX)."
26     echo "ninja - target ninja instead of GNU make"
27     echo "clangx.y - optional argument to build using clang version x.y."
28     echo "cross - optional argument to signify cross compilation,"
29     echo "      - will use ROOTFS_DIR environment variable if set."
30     echo "crosscomponent - optional argument to build cross-architecture component,"
31     echo "               - will use CAC_ROOTFS_DIR environment variable if set."
32     echo "pgoinstrument - generate instrumented code for profile guided optimization enabled binaries."
33     echo "configureonly - do not perform any builds; just configure the build."
34     echo "skipconfigure - skip build configuration."
35     echo "skipnative - do not build native components."
36     echo "skipmscorlib - do not build mscorlib.dll."
37     echo "skiptests - skip the tests in the 'tests' subdirectory."
38     echo "skipnuget - skip building nuget packages."
39     echo "portableLinux - build for Portable Linux Distribution"
40     echo "verbose - optional argument to enable verbose build output."
41     echo "-skiprestore: skip restoring packages ^(default: packages are restored during build^)."
42         echo "-disableoss: Disable Open Source Signing for System.Private.CoreLib."
43         echo "-sequential: force a non-parallel build ^(default is to build in parallel"
44         echo "   using all processors^)."
45         echo "-officialbuildid=^<ID^>: specify the official build ID to be used by this build."
46         echo "-Rebuild: passes /t:rebuild to the build projects."
47     echo "skipgenerateversion - disable version generation even if MSBuild is supported."
48     echo "cmakeargs - user-settable additional arguments passed to CMake."
49     echo "bindir - output directory (defaults to $__ProjectRoot/bin)"
50     echo "buildstandalonegc - builds the GC in a standalone mode. Can't be used with \"cmakeargs\"."
51
52     exit 1
53 }
54
55 initHostDistroRid()
56 {
57     if [ "$__HostOS" == "Linux" ]; then
58         if [ ! -e /etc/os-release ]; then
59             echo "WARNING: Can not determine runtime id for current distro."
60             __HostDistroRid=""
61         else
62             source /etc/os-release
63             __HostDistroRid="$ID.$VERSION_ID-$__HostArch"
64         fi
65     fi
66 }
67
68 initTargetDistroRid()
69 {
70     if [ $__CrossBuild == 1 ]; then
71         if [ "$__BuildOS" == "Linux" ]; then
72             if [ ! -e $ROOTFS_DIR/etc/os-release ]; then
73                 echo "WARNING: Can not determine runtime id for current distro."
74                 export __DistroRid=""
75             else
76                 source $ROOTFS_DIR/etc/os-release
77                 export __DistroRid="$ID.$VERSION_ID-$__BuildArch"
78             fi
79         fi
80     else
81         export __DistroRid="$__HostDistroRid"
82     fi
83
84     # Portable builds target the base RID only for Linux based platforms
85     if [ $__PortableLinux == 1 ]; then
86         export __DistroRid="linux-$__BuildArch"
87     fi
88 }
89
90 setup_dirs()
91 {
92     echo Setting up directories for build
93
94     mkdir -p "$__RootBinDir"
95     mkdir -p "$__BinDir"
96     mkdir -p "$__LogsDir"
97     mkdir -p "$__IntermediatesDir"
98
99     if [ $__CrossBuild == 1 ]; then
100         mkdir -p "$__CrossComponentBinDir"
101         mkdir -p "$__CrossCompIntermediatesDir"
102     fi
103 }
104
105 # Check the system to ensure the right prereqs are in place
106
107 check_prereqs()
108 {
109     echo "Checking prerequisites..."
110
111     # Check presence of CMake on the path
112     hash cmake 2>/dev/null || { echo >&2 "Please install cmake before running this script"; exit 1; }
113
114     # Check for clang
115     hash clang-$__ClangMajorVersion.$__ClangMinorVersion 2>/dev/null ||  hash clang$__ClangMajorVersion$__ClangMinorVersion 2>/dev/null ||  hash clang 2>/dev/null || { echo >&2 "Please install clang-$__ClangMajorVersion.$__ClangMinorVersion before running this script"; exit 1; }
116
117 }
118
119
120 generate_event_logging_sources()
121 {
122     if [ $__SkipCoreCLR == 1 ]; then
123         return
124     fi
125
126 # Event Logging Infrastructure
127    __GeneratedIntermediate="$__IntermediatesDir/Generated"
128    __GeneratedIntermediateEventProvider="$__GeneratedIntermediate/eventprovider_new"
129     if [[ -d "$__GeneratedIntermediateEventProvider" ]]; then
130         rm -rf  "$__GeneratedIntermediateEventProvider"
131     fi
132
133     if [[ ! -d "$__GeneratedIntermediate/eventprovider" ]]; then
134         mkdir -p "$__GeneratedIntermediate/eventprovider"
135     fi
136
137     mkdir -p "$__GeneratedIntermediateEventProvider"
138     if [[ $__SkipCoreCLR == 0 || $__ConfigureOnly == 1 ]]; then
139         echo "Laying out dynamically generated files consumed by the build system "
140         echo "Laying out dynamically generated Event Logging Test files"
141         $PYTHON -B -Wall -Werror "$__ProjectRoot/src/scripts/genXplatEventing.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --exc "$__ProjectRoot/src/vm/ClrEtwAllMeta.lst" --testdir "$__GeneratedIntermediateEventProvider/tests"
142
143         if  [[ $? != 0 ]]; then
144             exit
145         fi
146
147         #determine the logging system
148         case $__BuildOS in
149             Linux)
150                 echo "Laying out dynamically generated Event Logging Implementation of Lttng"
151                 $PYTHON -B -Wall -Werror "$__ProjectRoot/src/scripts/genXplatLttng.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__GeneratedIntermediateEventProvider"
152                 if  [[ $? != 0 ]]; then
153                     exit
154                 fi
155                 ;;
156             *)
157                 ;;
158         esac
159     fi
160
161     echo "Cleaning the temp folder of dynamically generated Event Logging files"
162     $PYTHON -B -Wall -Werror -c "import sys;sys.path.insert(0,\"$__ProjectRoot/src/scripts\"); from Utilities import *;UpdateDirectory(\"$__GeneratedIntermediate/eventprovider\",\"$__GeneratedIntermediateEventProvider\")"
163     if  [[ $? != 0 ]]; then
164         exit
165     fi
166
167     rm -rf "$__GeneratedIntermediateEventProvider"
168 }
169
170 build_native()
171 {
172     skipCondition=$1
173     platformArch="$2"
174     intermediatesForBuild="$3"
175     extraCmakeArguments="$4"
176     message="$5"
177
178     if [ $skipCondition == 1 ]; then
179         echo "Skipping $message build."
180         return
181     fi
182
183     # All set to commence the build
184     echo "Commencing build of $message for $__BuildOS.$__BuildArch.$__BuildType in $intermediatesForBuild"
185
186     generator=""
187     buildFile="Makefile"
188     buildTool="make"
189     if [ $__UseNinja == 1 ]; then
190         generator="ninja"
191         buildFile="build.ninja"
192         if ! buildTool=$(command -v ninja || command -v ninja-build); then
193            echo "Unable to locate ninja!" 1>&2
194            exit 1
195         fi
196     fi
197
198     if [ $__SkipConfigure == 0 ]; then
199         # if msbuild is not supported, then set __SkipGenerateVersion to 1
200         if [ $__isMSBuildOnNETCoreSupported == 0 ]; then __SkipGenerateVersion=1; fi
201         # Drop version.cpp file
202         __versionSourceFile="$intermediatesForBuild/version.cpp"
203         if [ $__SkipGenerateVersion == 0 ]; then
204             pwd
205             "$__ProjectRoot/run.sh" build -Project=$__ProjectDir/build.proj -generateHeaderUnix -NativeVersionSourceFile=$__versionSourceFile $__RunArgs $__UnprocessedBuildArgs
206         else
207             # Generate the dummy version.cpp, but only if it didn't exist to make sure we don't trigger unnecessary rebuild
208             __versionSourceLine="static char sccsid[] __attribute__((used)) = \"@(#)No version information produced\";"
209             if [ -e $__versionSourceFile ]; then
210                 read existingVersionSourceLine < $__versionSourceFile
211             fi
212             if [ "$__versionSourceLine" != "$existingVersionSourceLine" ]; then
213                 echo $__versionSourceLine > $__versionSourceFile
214             fi
215         fi
216
217         pushd "$intermediatesForBuild"
218         # Regenerate the CMake solution
219         echo "Invoking \"$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh\" \"$__ProjectRoot\" $__ClangMajorVersion $__ClangMinorVersion $platformArch $__BuildType $__CodeCoverage $__IncludeTests $generator $extraCmakeArguments $__cmakeargs"
220         "$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh" "$__ProjectRoot" $__ClangMajorVersion $__ClangMinorVersion $platformArch $__BuildType $__CodeCoverage $__IncludeTests $generator "$extraCmakeArguments" "$__cmakeargs"
221         popd
222     fi
223
224     if [ ! -f "$intermediatesForBuild/$buildFile" ]; then
225         echo "Failed to generate $message build project!"
226         exit 1
227     fi
228     
229     # Get the number of processors available to the scheduler
230     # Other techniques such as `nproc` only get the number of
231     # processors available to a single process.
232     if [ `uname` = "FreeBSD" ]; then
233         NumProc=`sysctl hw.ncpu | awk '{ print $2+1 }'`
234     elif [ `uname` = "NetBSD" ]; then
235         NumProc=$(($(getconf NPROCESSORS_ONLN)+1))
236     else
237         NumProc=$(($(getconf _NPROCESSORS_ONLN)+1))
238     fi
239
240     # Build
241     if [ $__ConfigureOnly == 1 ]; then
242         echo "Finish configuration & skipping $message build."
243         return
244     fi
245
246     # Check that the makefiles were created.
247     pushd "$intermediatesForBuild"
248
249     echo "Executing $buildTool install -j $NumProc"
250
251     $buildTool install -j $NumProc
252     if [ $? != 0 ]; then
253         echo "Failed to build $message."
254         exit 1
255     fi
256
257     popd
258 }
259
260 build_cross_arch_component()
261 {
262     __SkipCrossArchBuild=1
263     TARGET_ROOTFS=""
264     # check supported cross-architecture components host(__HostArch)/target(__BuildArch) pair
265     if [[ "$__BuildArch" == "arm" && "$__CrossArch" == "x86" ]]; then
266         export CROSSCOMPILE=0
267         __SkipCrossArchBuild=0
268
269         # building x64-host/arm-target cross-architecture component need to use cross toolchain of x86
270         if [ "$__HostArch" == "x64" ]; then
271             export CROSSCOMPILE=1
272         fi
273     else
274         # not supported
275         return
276     fi    
277     
278     export __CMakeBinDir="$__CrossComponentBinDir"
279     export CROSSCOMPONENT=1
280     __IncludeTests=
281
282     if [ $CROSSCOMPILE == 1 ]; then
283         TARGET_ROOTFS="$ROOTFS_DIR"
284         if [ -n "$CAC_ROOTFS_DIR" ]; then
285             export ROOTFS_DIR="$CAC_ROOTFS_DIR"
286         else
287             export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__CrossArch"
288         fi
289     fi
290
291     __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_ARCH=$__BuildArch -DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument"
292     build_native $__SkipCrossArchBuild "$__CrossArch" "$__CrossCompIntermediatesDir" "$__ExtraCmakeArgs" "cross-architecture component"
293    
294     # restore ROOTFS_DIR, CROSSCOMPONENT, and CROSSCOMPILE 
295     if [ -n "$TARGET_ROOTFS" ]; then
296         export ROOTFS_DIR="$TARGET_ROOTFS"
297     fi
298     export CROSSCOMPONENT=
299     export CROSSCOMPILE=1
300 }
301
302 isMSBuildOnNETCoreSupported()
303 {
304     # This needs to be updated alongwith corresponding changes to netci.groovy.
305     __isMSBuildOnNETCoreSupported=0
306
307     if [ "$__HostArch" == "x64" ]; then
308         if [ "$__HostOS" == "Linux" ]; then
309             case "$__HostDistroRid" in
310                 "centos.7-x64")
311                     __isMSBuildOnNETCoreSupported=1
312                     ;;
313                 "debian.8-x64")
314                     __isMSBuildOnNETCoreSupported=1
315                     ;;
316                 "fedora.23-x64")
317                     __isMSBuildOnNETCoreSupported=1
318                     ;;
319                 "fedora.24-x64")
320                     __isMSBuildOnNETCoreSupported=1
321                     ;;
322                 "opensuse.13.2-x64")
323                     __isMSBuildOnNETCoreSupported=1
324                     ;;
325                 "opensuse.42.1-x64")
326                     __isMSBuildOnNETCoreSupported=1
327                     ;;
328                 "rhel.7"*"-x64")
329                     __isMSBuildOnNETCoreSupported=1
330                     ;;
331                 "ubuntu.14.04-x64")
332                     __isMSBuildOnNETCoreSupported=1
333                     ;;
334                 "ubuntu.16.04-x64")
335                     __isMSBuildOnNETCoreSupported=1
336                     ;;
337                 "ubuntu.16.10-x64")
338                     __isMSBuildOnNETCoreSupported=1
339                     ;;
340                 "alpine.3.4.3-x64")
341                     __isMSBuildOnNETCoreSupported=1
342                     ;;
343                 *)
344             esac
345         elif [ "$__HostOS" == "OSX" ]; then
346             __isMSBuildOnNETCoreSupported=1
347         fi
348     fi
349 }
350
351 build_CoreLib_ni()
352 {
353     if [ $__SkipCoreCLR == 0 -a -e $__BinDir/crossgen ]; then
354         echo "Generating native image for System.Private.CoreLib."
355         $__BinDir/crossgen $__BinDir/System.Private.CoreLib.dll
356         if [ $? -ne 0 ]; then
357             echo "Failed to generate native image for System.Private.CoreLib."
358             exit 1
359         fi
360
361         echo "Generating native image for MScorlib Facade."
362         $__BinDir/crossgen $__BinDir/mscorlib.dll
363         if [ $? -ne 0 ]; then
364             echo "Failed to generate native image for mscorlib facade."
365             exit 1
366         fi
367
368         if [ "$__BuildOS" == "Linux" ]; then
369             echo "Generating symbol file for System.Private.CoreLib."
370             $__BinDir/crossgen /CreatePerfMap $__BinDir $__BinDir/System.Private.CoreLib.ni.dll
371             if [ $? -ne 0 ]; then
372                 echo "Failed to generate symbol file for System.Private.CoreLib."
373                 exit 1
374             fi
375         fi
376     fi
377 }
378
379 build_CoreLib()
380 {
381
382     if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
383         echo "System.Private.CoreLib.dll build unsupported."
384         return
385     fi
386
387     if [ $__SkipMSCorLib == 1 ]; then
388        echo "Skipping building System.Private.CoreLib."
389        return
390     fi
391
392     echo "Commencing build of managed components for $__BuildOS.$__BuildArch.$__BuildType"
393
394     # Invoke MSBuild
395     $__ProjectRoot/run.sh build -Project=$__ProjectDir/build.proj -MsBuildLog="/flp:Verbosity=normal;LogFile=$__LogsDir/System.Private.CoreLib_$__BuildOS__$__BuildArch__$__BuildType.log" -BuildTarget -__IntermediatesDir=$__IntermediatesDir -__RootBinDir=$__RootBinDir -BuildNugetPackage=false -UseSharedCompilation=false $__RunArgs $__UnprocessedBuildArgs
396
397     if [ $? -ne 0 ]; then
398         echo "Failed to build managed components."
399         exit 1
400     fi
401
402     # The cross build generates a crossgen with the target architecture.
403     if [ $__CrossBuild != 1 ]; then
404        # The architecture of host pc must be same architecture with target.
405        if [[ ( "$__HostArch" == "$__BuildArch" ) ]]; then
406            build_CoreLib_ni
407        elif [[ ( "$__HostArch" == "x64" ) && ( "$__BuildArch" == "x86" ) ]]; then
408            build_CoreLib_ni
409        elif [[ ( "$__HostArch" == "arm64" ) && ( "$__BuildArch" == "arm" ) ]]; then
410            build_CoreLib_ni
411        else 
412            exit 1
413        fi
414     fi 
415 }
416
417 generate_NugetPackages()
418 {
419     # We can only generate nuget package if we also support building mscorlib as part of this build.
420     if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
421         echo "Nuget package generation unsupported."
422         return
423     fi
424
425     # Since we can build mscorlib for this OS, did we build the native components as well?
426     if [ $__SkipCoreCLR == 1 ]; then
427         echo "Unable to generate nuget packages since native components were not built."
428         return
429     fi
430
431     echo "Generating nuget packages for "$__BuildOS
432
433     # Build the packages
434     $__ProjectRoot/run.sh build -Project=$__SourceDir/.nuget/packages.builds -MsBuildLog="/flp:Verbosity=normal;LogFile=$__LogsDir/Nuget_$__BuildOS__$__BuildArch__$__BuildType.log" -BuildTarget -__IntermediatesDir=$__IntermediatesDir -__RootBinDir=$__RootBinDir -BuildNugetPackage=false -UseSharedCompilation=false $__RunArgs $__UnprocessedBuildArgs
435
436     if [ $? -ne 0 ]; then
437         echo "Failed to generate Nuget packages."
438         exit 1
439     fi
440 }
441
442 echo "Commencing CoreCLR Repo build"
443
444 # Argument types supported by this script:
445 #
446 # Build architecture - valid values are: x64, ARM.
447 # Build Type         - valid values are: Debug, Checked, Release
448 #
449 # Set the default arguments for build
450
451 # Obtain the location of the bash script to figure out where the root of the repo is.
452 __ProjectRoot="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
453
454 # Use uname to determine what the CPU is.
455 CPUName=$(uname -p)
456 # Some Linux platforms report unknown for platform, but the arch for machine.
457 if [ "$CPUName" == "unknown" ]; then
458     CPUName=$(uname -m)
459 fi
460
461 case $CPUName in
462     i686)
463         echo "Unsupported CPU $CPUName detected, build might not succeed!"
464         __BuildArch=x86
465         __HostArch=x86
466         ;;
467
468     x86_64)
469         __BuildArch=x64
470         __HostArch=x64
471         ;;
472
473     armv7l)
474         echo "Unsupported CPU $CPUName detected, build might not succeed!"
475         __BuildArch=arm
476         __HostArch=arm
477         ;;
478
479     aarch64)
480         __BuildArch=arm64
481         __HostArch=arm64
482         ;;
483
484     *)
485         echo "Unknown CPU $CPUName detected, configuring as if for x64"
486         __BuildArch=x64
487         __HostArch=x64
488         ;;
489 esac
490
491 # Use uname to determine what the OS is.
492 OSName=$(uname -s)
493 case $OSName in
494     Linux)
495         __BuildOS=Linux
496         __HostOS=Linux
497         ;;
498
499     Darwin)
500         __BuildOS=OSX
501         __HostOS=OSX
502         ;;
503
504     FreeBSD)
505         __BuildOS=FreeBSD
506         __HostOS=FreeBSD
507         ;;
508
509     OpenBSD)
510         __BuildOS=OpenBSD
511         __HostOS=OpenBSD
512         ;;
513
514     NetBSD)
515         __BuildOS=NetBSD
516         __HostOS=NetBSD
517         ;;
518
519     SunOS)
520         __BuildOS=SunOS
521         __HostOS=SunOS
522         ;;
523
524     *)
525         echo "Unsupported OS $OSName detected, configuring as if for Linux"
526         __BuildOS=Linux
527         __HostOS=Linux
528         ;;
529 esac
530
531 __BuildType=Debug
532 __CodeCoverage=
533 __IncludeTests=Include_Tests
534
535 # Set the various build properties here so that CMake and MSBuild can pick them up
536 __ProjectDir="$__ProjectRoot"
537 __SourceDir="$__ProjectDir/src"
538 __PackagesDir="$__ProjectDir/packages"
539 __RootBinDir="$__ProjectDir/bin"
540 __UnprocessedBuildArgs=
541 __RunArgs=
542 __MSBCleanBuildArgs=
543 __UseNinja=0
544 __VerboseBuild=0
545 __PgoInstrument=0
546 __ConfigureOnly=0
547 __SkipConfigure=0
548 __SkipRestore=""
549 __SkipNuget=0
550 __SkipCoreCLR=0
551 __SkipMSCorLib=0
552 __CrossBuild=0
553 __ClangMajorVersion=0
554 __ClangMinorVersion=0
555 __NuGetPath="$__PackagesDir/NuGet.exe"
556 __HostDistroRid=""
557 __DistroRid=""
558 __cmakeargs=""
559 __SkipGenerateVersion=0
560 __DoCrossArchBuild=0
561 __PortableLinux=0
562
563 while :; do
564     if [ $# -le 0 ]; then
565         break
566     fi
567
568     lowerI="$(echo $1 | awk '{print tolower($0)}')"
569     case $lowerI in
570         -\?|-h|--help)
571             usage
572             exit 1
573             ;;
574
575         x86)
576             __BuildArch=x86
577             ;;
578
579         x64)
580             __BuildArch=x64
581             ;;
582
583         arm)
584             __BuildArch=arm
585             ;;
586
587         armel)
588             __BuildArch=armel
589             ;;
590
591         arm64)
592             __BuildArch=arm64
593             ;;
594
595         debug)
596             __BuildType=Debug
597             ;;
598
599         checked)
600             __BuildType=Checked
601             ;;
602
603         release)
604             __BuildType=Release
605             ;;
606
607         coverage)
608             __CodeCoverage=Coverage
609             ;;
610
611         cross)
612             __CrossBuild=1
613             ;;
614             
615                 portablelinux)
616             if [ "$__BuildOS" == "Linux" ]; then
617                 __PortableLinux=1
618             else
619                 echo "ERROR: portableLinux not supported for non-Linux platforms."
620                 exit 1
621             fi
622             ;;
623             
624         verbose)
625         __VerboseBuild=1
626         ;;
627
628         clang3.5)
629             __ClangMajorVersion=3
630             __ClangMinorVersion=5
631             ;;
632
633         clang3.6)
634             __ClangMajorVersion=3
635             __ClangMinorVersion=6
636             ;;
637
638         clang3.7)
639             __ClangMajorVersion=3
640             __ClangMinorVersion=7
641             ;;
642
643         clang3.8)
644             __ClangMajorVersion=3
645             __ClangMinorVersion=8
646             ;;
647
648         clang3.9)
649             __ClangMajorVersion=3
650             __ClangMinorVersion=9
651             ;;
652
653         ninja)
654             __UseNinja=1
655             ;;
656
657         pgoinstrument)
658             __PgoInstrument=1
659             ;;
660
661         configureonly)
662             __ConfigureOnly=1
663             __SkipMSCorLib=1
664             __SkipNuget=1
665             ;;
666
667         skipconfigure)
668             __SkipConfigure=1
669             ;;
670
671         skipnative)
672             # Use "skipnative" to use the same option name as build.cmd.
673             __SkipCoreCLR=1
674             ;;
675
676         skipcoreclr)
677             # Accept "skipcoreclr" for backwards-compatibility.
678             __SkipCoreCLR=1
679             ;;
680
681         crosscomponent)
682             __DoCrossArchBuild=1
683             ;;
684
685         skipmscorlib)
686             __SkipMSCorLib=1
687             ;;
688
689         skipgenerateversion)
690             __SkipGenerateVersion=1
691             ;;
692
693         includetests)
694             ;;
695
696         skiptests)
697             __IncludeTests=
698             ;;
699
700         skipnuget)
701             __SkipNuget=1
702             ;;
703
704         cmakeargs)
705             if [ -n "$2" ]; then
706                 __cmakeargs="$2"
707                 shift
708             else
709                 echo "ERROR: 'cmakeargs' requires a non-empty option argument"
710                 exit 1
711             fi
712             ;;
713
714         bindir)
715             if [ -n "$2" ]; then
716                 __RootBinDir="$2"
717                 if [ ! -d $__RootBinDir ]; then
718                     mkdir $__RootBinDir
719                 fi
720                 __RootBinParent=$(dirname $__RootBinDir)
721                 __RootBinName=${__RootBinDir##*/}
722                 __RootBinDir="$(cd $__RootBinParent &>/dev/null && printf %s/%s $PWD $__RootBinName)"
723                 shift
724             else
725                 echo "ERROR: 'bindir' requires a non-empty option argument"
726                 exit 1
727             fi
728             ;;
729         buildstandalonegc)
730             __cmakeargs="-DFEATURE_STANDALONE_GC=1"
731             ;;
732         *)
733             __UnprocessedBuildArgs="$__UnprocessedBuildArgs $1"
734             ;;
735     esac
736
737     shift
738 done
739
740 __RunArgs="-BuildArch=$__BuildArch -BuildType=$__BuildType -BuildOS=$__BuildOS"
741
742 # Configure environment if we are doing a verbose build
743 if [ $__VerboseBuild == 1 ]; then
744     export VERBOSE=1
745         __RunArgs="$__RunArgs -verbose"
746 fi
747
748 # Set default clang version
749 if [[ $__ClangMajorVersion == 0 && $__ClangMinorVersion == 0 ]]; then
750     if [ $__CrossBuild == 1 ]; then
751         __ClangMajorVersion=3
752         __ClangMinorVersion=6
753     else
754         __ClangMajorVersion=3
755         __ClangMinorVersion=5
756     fi
757 fi
758
759 # Set dependent variables
760 __LogsDir="$__RootBinDir/Logs"
761
762 # init the host distro name
763 initHostDistroRid
764
765 # Set the remaining variables based upon the determined build configuration
766 __BinDir="$__RootBinDir/Product/$__BuildOS.$__BuildArch.$__BuildType"
767 __PackagesBinDir="$__BinDir/.nuget"
768 __ToolsDir="$__RootBinDir/tools"
769 __TestWorkingDir="$__RootBinDir/tests/$__BuildOS.$__BuildArch.$__BuildType"
770 export __IntermediatesDir="$__RootBinDir/obj/$__BuildOS.$__BuildArch.$__BuildType"
771 __TestIntermediatesDir="$__RootBinDir/tests/obj/$__BuildOS.$__BuildArch.$__BuildType"
772 __isMSBuildOnNETCoreSupported=0
773 __CrossComponentBinDir="$__BinDir"
774 __CrossCompIntermediatesDir="$__IntermediatesDir/crossgen"
775
776 __CrossArch="$__HostArch"
777 if [[ "$__HostArch" == "x64" && "$__BuildArch" == "arm" ]]; then
778     __CrossArch="x86"
779 fi
780 if [ $__CrossBuild == 1 ]; then
781     __CrossComponentBinDir="$__CrossComponentBinDir/$__CrossArch"
782 fi
783 __CrossgenCoreLibLog="$__LogsDir/CrossgenCoreLib_$__BuildOS.$BuildArch.$__BuildType.log"
784 __CrossgenExe="$__CrossComponentBinDir/crossgen"
785
786 # Init if MSBuild for .NET Core is supported for this platform
787 isMSBuildOnNETCoreSupported
788
789 # CI_SPECIFIC - On CI machines, $HOME may not be set. In such a case, create a subfolder and set the variable to set.
790 # This is needed by CLI to function.
791 if [ -z "$HOME" ]; then
792     if [ ! -d "$__ProjectDir/temp_home" ]; then
793         mkdir temp_home
794     fi
795     export HOME=$__ProjectDir/temp_home
796     echo "HOME not defined; setting it to $HOME"
797 fi
798
799 # Specify path to be set for CMAKE_INSTALL_PREFIX.
800 # This is where all built CoreClr libraries will copied to.
801 export __CMakeBinDir="$__BinDir"
802
803 # Configure environment if we are doing a cross compile.
804 if [ $__CrossBuild == 1 ]; then
805     export CROSSCOMPILE=1
806     if ! [[ -n "$ROOTFS_DIR" ]]; then
807         export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__BuildArch"
808     fi
809 fi
810
811 # init the target distro name
812 initTargetDistroRid
813
814 # Make the directories necessary for build if they don't exist
815 setup_dirs
816
817 # Check prereqs.
818 check_prereqs
819
820 # Generate event logging infrastructure sources
821 generate_event_logging_sources
822
823 # Build the coreclr (native) components.
824 __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument"
825 build_native $__SkipCoreCLR "$__BuildArch" "$__IntermediatesDir" "$__ExtraCmakeArgs" "CoreCLR component"
826
827 # Build cross-architecture components
828 if [[ $__CrossBuild == 1 && $__DoCrossArchBuild == 1 ]]; then
829     build_cross_arch_component
830 fi
831
832 # Build System.Private.CoreLib.
833
834 build_CoreLib
835
836 # Generate nuget packages
837 if [ $__SkipNuget != 1 ]; then
838     generate_NugetPackages
839 fi
840
841
842 # Build complete
843
844 echo "Repo successfully built."
845 echo "Product binaries are available at $__BinDir"
846 exit 0